# disable python bytecompile outside python dirs
%global _python_bytecompile_extra 0

# disable unsecure webkit1 support
%bcond_with webkit1

# bcond_with gtk3    = gtk2
# bcond_without gtk3 = gtk3
%bcond_without gtk3

# build with/without 2.8 compatibility
%bcond_without compat28

%define gtkver %{?with_gtk3:3}%{!?with_gtk3:2}

%define oname           wxWidgets

%define major           3
%define api             3.1

%define libnameu        %mklibname wxgtku %{api} %{major}
%define libnameudev     %mklibname wxgtku %{api} -d
%define libglu          %mklibname wxgtkugl %{api} %{major}


Summary:        GTK+ port of the wxWidgets library
Name:           wxgtk%{api}
Version:        3.1.3
Release:        %mkrel 2
License:        wxWidgets Library Licence
Group:          System/Libraries
URL:            http://www.wxwidgets.org/
Source0:        https://github.com/wxWidgets/wxWidgets/releases/download/v%{version}/%{oname}-%{version}.tar.xz
Patch0:         wxWidgets-2.9.5-fix-linking.patch
Patch1:         wxWidgets-2.9.5-multiarch-includes.patch
Patch2:         wxWidgets-3.0.4-collision.patch
Patch3:		    wxGTK3-3.0.3-abicheck.patch
BuildRequires:  bakefile
BuildRequires:  pkgconfig(libjpeg)
BuildRequires:  pkgconfig(libtiff-4)
BuildRequires:  pkgconfig(expat)
BuildRequires:  pkgconfig(cppunit)
BuildRequires:  pkgconfig(gl)
BuildRequires:  pkgconfig(glu)
BuildRequires:  pkgconfig(gstreamer-1.0)
BuildRequires:  pkgconfig(gstreamer-plugins-base-1.0)
%if %{with gtk3}
BuildRequires:  pkgconfig(gtk+-3.0)
BuildRequires:  pkgconfig(webkit2gtk-4.0)
%else
BuildRequires:  pkgconfig(gtk+-2.0)
%if %{with webkit1}
BuildRequires:  pkgconfig(webkit-1.0) >= 1.3.1
%endif
%endif
BuildRequires:  pkgconfig(libmspack)
BuildRequires:  pkgconfig(libnotify) >= 0.7
BuildRequires:  pkgconfig(libpng)
BuildRequires:  pkgconfig(sdl2)
BuildRequires:  pkgconfig(sm)
BuildRequires:  pkgconfig(xxf86vm)
BuildRequires:  pkgconfig(zlib)
Provides:       wxgtk = %{version}-%{release}
Requires:  lib64wxgtku3.1_3
Requires:  lib64wxgtkugl3.1_3

%description
wxWidgets is a free C++ library for cross-platform GUI development.
With wxWidgets, you can create applications for different GUIs (GTK+,
Motif/LessTif, MS Windows, Mac) from the same source code.

%package -n %{libnameu}
Group:          System/Libraries
Summary:        Base shared library part of wxGTK - Unicode enabled
Requires:       %{name} >= %{version}-%{release}
#Obsoletes:      lib64wxgtku3.1_2

%description -n %{libnameu}
wxWidgets is a free C++ library for cross-platform GUI development.
With wxWidgets, you can create applications for different GUIs (GTK+,
Motif/LessTif, MS Windows, Mac) from the same source code.

This package contains the library needed to run programs dynamically
linked with the unicode enabled version of %{name}.


%package -n %{libnameudev}
Summary:        Header files and development documentation for wxGTK - unicode
Group:          Development/C++
Requires:       %{libnameu} = %{version}-%{release}
Requires:       %{libglu} = %{version}-%{release}
Provides:       libwxgtku%{api}-devel = %{version}-%{release}
Provides:       wxgtku%{api}-devel = %{version}-%{release}
Provides:       wxgtk%{api}-devel = %{version}-%{release}
Provides:       libwxgtk%{api}-devel = %{version}-%{release}
Provides:       %{name}-devel = %{version}-%{release}
Provides:       wxgtk-devel = %{version}-%{release}
Requires(post):         update-alternatives
Requires(postun):       update-alternatives


%description -n %{libnameudev}
Header files for the unicode enabled version of wxGTK, the GTK+ port of
the wxWidgets library.

%package  -n %{libglu}
Summary:        GTK+ port of the wxWidgets library, OpenGl add-on - unicode
Group:          System/Libraries
#Obsoletes:      lib64wxgtkugl3.1_2

%description -n %{libglu}
OpenGl add-on library for the unicode enabled version of wxGTK, the
GTK+ port of the wxWidgets library.

%prep
%setup -qn %{oname}-%{version}
%apply_patches

# (fwang) Don't promote LDFLAGS in wx-config
sed -i -e 's/@LDFLAGS@//' -e 's/@WXCONFIG_CXXFLAGS@//' wx-config.in

# fix plugin dir for 64-bit
sed -i -e 's|/lib|/%{_lib}|' src/unix/stdpaths.cpp

find samples demos -name .cvsignore -delete

%build
aclocal --force -I$PWD/build/aclocal
autoconf -f
libtoolize --copy --force
# --disable-optimise prevents our $RPM_OPT_FLAGS being overridden
# (see OPTIMISE in configure).
# this code dereferences type-punned pointers like there's no tomorrow.
CFLAGS="%{optflags} -fno-strict-aliasing"
CXXFLAGS="%{optflags} -fno-strict-aliasing"

%configure2_5x \
        --enable-intl \
        --with-gtk=%{gtkver} \
        --with-sdl \
        --with-libmspack \
        --with-libpng=sys \
        --with-libjpeg=sys \
        --with-libtiff=sys \
        --with-zlib=sys \
        --with-expat=sys \
        --with-regex=builtin \
        --disable-optimise \
        --enable-calendar \
        %{?with_compat28:--enable-compat28} \
        --enable-controls \
        --enable-msgdlg \
        --enable-dirdlg \
        --enable-numberdlg \
        --enable-splash \
        --enable-textdlg \
        --enable-graphics_ctx \
        --enable-grid \
        --enable-catch_segvs \
        --enable-mediactrl \
        --enable-dataviewctrl \
        --enable-permissive \
        --enable-ipv6 \
        --disable-rpath

%make_build
# Why isn't this this part of the main build? Need to investigate.
%make_build -C locale allmo

#gw prepare samples
pushd demos
        make clean
        rm -f makefile* demos.bkl
popd

pushd samples
        make clean
        rm -f makefile* samples.bkl
popd

find demos samples -name Makefile|xargs perl -pi -e 's^CXXC =.*^CXXC=\$(CXX) `wx-config --cflags`^'
find demos samples -name Makefile|xargs perl -pi -e 's^EXTRALIBS =.*^EXTRALIBS=^'
find demos samples -name Makefile|xargs perl -pi -e 's^SAMPLES_RPATH_FLAG =.*^SAMPLES_RPATH_FLAG=^'

%install
%make_install

# dummy translation file
find %{buildroot} -name "wxmsw.mo" -delete


%find_lang wxstd31


%post -n %{libnameudev}
%{_sbindir}/update-alternatives \
        --install %{_bindir}/wx-config \
        wx-config \
        %{_bindir}/wx-config-%{api} \
        30

%{_sbindir}/update-alternatives \
        --install %{_bindir}/wxrc \
        wxrc \
        %{_bindir}/wxrc-%{api} \
        30

%postun -n %{libnameudev}
if [ $1 -eq 0 ]; then
%{_sbindir}/update-alternatives \
        --remove wx-config \
        %{_bindir}/wx-config-%{api}

%{_sbindir}/update-alternatives \
        --remove wxrc \
        %{_bindir}/wxrc-%{api}
fi

%files -f wxstd31.lang
%doc *.txt

%files -n %{libnameu}
%{_libdir}/libwx_baseu-%{api}.so.%{major}*
%{_libdir}/libwx_baseu_net-%{api}.so.%{major}*
%{_libdir}/libwx_baseu_xml-%{api}.so.%{major}*
%{_libdir}/libwx_gtk%{gtkver}u_adv-%{api}.so.%{major}*
%{_libdir}/libwx_gtk%{gtkver}u_aui-%{api}.so.%{major}*
%{_libdir}/libwx_gtk%{gtkver}u_core-%{api}.so.%{major}*
%{_libdir}/libwx_gtk%{gtkver}u_html-%{api}.so.%{major}*
%{_libdir}/libwx_gtk%{gtkver}u_media-%{api}.so.%{major}*
%{_libdir}/libwx_gtk%{gtkver}u_propgrid-%{api}.so.%{major}*
%{_libdir}/libwx_gtk%{gtkver}u_qa-%{api}.so.%{major}*
%{_libdir}/libwx_gtk%{gtkver}u_ribbon-%{api}.so.%{major}*
%{_libdir}/libwx_gtk%{gtkver}u_richtext-%{api}.so.%{major}*
%{_libdir}/libwx_gtk%{gtkver}u_stc-%{api}.so.%{major}*
%{_libdir}/libwx_gtk%{gtkver}u_webview-%{api}.so.%{major}*
%{_libdir}/libwx_gtk%{gtkver}u_xrc-%{api}.so.%{major}*
%{_libdir}/wx/%{version}/web-extensions/webkit2_extu-%{version}.so

%files -n %{libnameudev}
%doc samples/ docs/ demos/
%{_bindir}/wx-config-%{api}
%{_bindir}/wxrc-%{api}
%{_includedir}/wx-%{api}/
%dir %{_libdir}/wx/
%dir %{_libdir}/wx/include/
%dir %{_libdir}/wx/include/gtk%{gtkver}-unicode-%{api}/
%dir %{_libdir}/wx/include/gtk%{gtkver}-unicode-%{api}/wx/
%dir %{_libdir}/wx/config
%{_libdir}/wx/config/gtk%{gtkver}-unicode-%{api}
%{_libdir}/wx/include/gtk%{gtkver}-unicode-%{api}/wx/setup.h
%{_libdir}/libwx_baseu-%{api}.so
%{_libdir}/libwx_baseu_net-%{api}.so
%{_libdir}/libwx_baseu_xml-%{api}.so
%{_libdir}/libwx_gtk%{gtkver}u_adv-%{api}.so
%{_libdir}/libwx_gtk%{gtkver}u_aui-%{api}.so
%{_libdir}/libwx_gtk%{gtkver}u_core-%{api}.so
%{_libdir}/libwx_gtk%{gtkver}u_gl-%{api}.so
%{_libdir}/libwx_gtk%{gtkver}u_html-%{api}.so
%{_libdir}/libwx_gtk%{gtkver}u_media-%{api}.so
%{_libdir}/libwx_gtk%{gtkver}u_propgrid-%{api}.so
%{_libdir}/libwx_gtk%{gtkver}u_qa-%{api}.so
%{_libdir}/libwx_gtk%{gtkver}u_ribbon-%{api}.so
%{_libdir}/libwx_gtk%{gtkver}u_richtext-%{api}.so
%{_libdir}/libwx_gtk%{gtkver}u_stc-%{api}.so
%if %{with webkit1} || %{with gtk3}
%{_libdir}/libwx_gtk%{gtkver}u_webview-%{api}.so
%endif
%{_libdir}/libwx_gtk%{gtkver}u_xrc-%{api}.so
%{_datadir}/bakefile/presets/wx*
%{_datadir}/aclocal/wxwin31.m4

%files -n %{libglu}
%{_libdir}/libwx_gtk%{gtkver}u_gl-%{api}.so.%{major}*


%changelog
* Fri Mar 27 2020 tex - 3.1.3-2pclos2020
- fix spec file

* Wed Feb 19 2020 onkelho <oh.quait at gmail.com> - 3.1.3-1pclos2020
- new ver-rel

* Sat Oct 04 2019 tex - 3.1.2-1pclos2019
- new version
